---- CombustionTracker -- made by Tracerus on Wrathbringer (EU) ----------

CombustionTracker_Version = "1.2";
CombustionTracker_maxCrits = 3;
CombustionTracker_CritsLeft = CombustionTracker_maxCrits;
CombustionTracker_CombustionActive = false;
CombustionTracker_VariablesLoaded = false;
CombustionTracker_TextureName = "(.+)SealOfFire";

function CombustionTracker_OnEvent()
	if( event=="PLAYER_ENTERING_WORLD") then
		this:UnregisterEvent("PLAYER_ENTERING_WORLD");
		CombustionTracker_VariablesLoaded = true;
		
		--register all events we need
		this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
		this:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_SELF");
		this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS");
		this:RegisterEvent("PLAYER_AURAS_CHANGED");
		this:RegisterEvent("PLAYER_DEAD");
	
		--if we logged out with active combustion we still have the buff
		if( CombustionTracker_CombustionActive ) then
			--place text under combustion buff icon and show it
			CombustionTracker_UpdateText();
			CombustionTracker_UpdateTextPosition();
			CombustionTracker_MainFrame_CritNumber:Show();
			DEFAULT_CHAT_FRAME:AddMessage("wird angezeigt");
		end
	end
	
	--do nothin if variables have not been loaded yet
	if( not CombustionTracker_VariablesLoaded ) then
		return;
	end
	
	--if we got a buff and system message is equal to combustion gain message ...
	if( event=="CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS" and arg1==COMBUSTIONTRACKER_AURAGAIN ) then
		CombustionTracker_CritsLeft = CombustionTracker_maxCrits;
		CombustionTracker_UpdateText();
		CombustionTracker_UpdateTextPosition();
		CombustionTracker_CombustionActive = true;
		CombustionTracker_MainFrame_CritNumber:Show();

	--everything else only matters if combustion is already active
	elseif( CombustionTracker_CombustionActive ) then

		--if a buff is gone and system message is equal to combustion fade message        OR if we died
		if( (event=="CHAT_MSG_SPELL_AURA_GONE_SELF" and arg1==COMBUSTIONTRACKER_AURALOSE) or event=="PLAYER_DEAD" ) then
			CombustionTracker_MainFrame_CritNumber:Hide();
			CombustionTracker_CombustionActive = false;

		--...or did we just do damage...
		elseif( event=="CHAT_MSG_SPELL_SELF_DAMAGE" ) then
			--if we had a critical hit                       and it is a firespell
			if( string.find(arg1, COMBUSTIONTRACKER_CRITHIT) and IsFirespellMessage(arg1) ) then
				--decrease number of crits left
				CombustionTracker_CritsLeft = CombustionTracker_CritsLeft-1;

				--sometimes it takes a while until buff fades, so hide the UI text if there are 0 crits left
				if( CombustionTracker_CritsLeft<=0 ) then
					CombustionTracker_MainFrame_CritNumber:Hide();
					CombustionTracker_CombustionActive = false;
				--else update text
				else
					CombustionTracker_UpdateText();
				end
			end

		--if any buff changed we maybe have to reposition the UI text ...
		elseif( event=="PLAYER_AURAS_CHANGED" ) then
			--...so we update it
			CombustionTracker_UpdateTextPosition();
		end

	end
end

--updates the text position for standard buff bar
function CombustionTracker_UpdateTextPosition()
	--go through all the buffs 
	for i = 0, 23 do
		local buffIndex, untilCancelled = GetPlayerBuff(i, "HELPFUL");
		--test if we found a buff and get its texturename
		if ( buffIndex >= 0 ) then
			local buffTexture = GetPlayerBuffTexture(buffIndex);	
			
			--test if it is combustion texture
			if (string.find(buffTexture, CombustionTracker_TextureName)) then
			
				--generate tooltip for this buff and extract buffname
				CombustionTracker_Tooltip:SetOwner(UIParent, "ANCHOR_NONE");
				CombustionTracker_Tooltip:SetPlayerBuff(buffIndex);
				local buffName = tostring(CombustionTracker_TooltipTextLeft1:GetText());
				CombustionTracker_Tooltip:Hide();
				
				--check if this is really combustion buff (and not Fire Resistance Aura)
				if ( COMBUSTIONTRACKER_COMBUSTION == buffName ) then
					--place UI text under combustion buff and update text
					CombustionTracker_MainFrame_CritNumber:SetPoint("TOP", "BuffButton"..i, "BOTTOM", -2, -2);
					--CombustionTracker_MainFrame_CritNumber:Show();

					--we found combustion buff and can stop going through bufflist
					return;
				end
			end
		end
	end
	--no combustion buff found -> hide text
	CombustionTracker_MainFrame_CritNumber:Hide();
	--CombustionTracker_CombustionActive = false;
end

--updates the text position for ElkanoBuffBar
function CombustionTracker_UpdateTextPosition_ElkBuffBar()
	--go through all the buffs 
	for i = 1, 24 do
		--get buff name directly out of ElkBuffBars
		local name = getglobal("ElkBuffButton"..i.."DescribeText");
		if ( name and COMBUSTIONTRACKER_COMBUSTION==tostring(name:GetText()) ) then
			--set button as parent for scaling and anchor text to it
			CombustionTracker_MainFrame_CritNumber:SetParent("ElkBuffButton"..i);
			CombustionTracker_MainFrame_CritNumber:SetPoint("RIGHT", "ElkBuffButton"..i, "RIGHT", -2, 0);
			--CombustionTracker_MainFrame_CritNumber:Show();
			
			--we found combustion buff and can stop going through bufflist
			return;
		end
	end
	--no combustion buff found -> hide text
	CombustionTracker_MainFrame_CritNumber:Hide();
	--CombustionTracker_CombustionActive = false;
end

--updates the text position for SatrinaBuffFrame
function CombustionTracker_UpdateTextPosition_SatrinaBuff()
	--go through all the Satrina buff buttons
	for i = 1, 24 do
		--get a button
		local buffButton = getglobal("SatrinaBuffButton"..i);
		--extract buff name out of buttons tooltip
		if( buffButton and buffButton.index ) then
			--generate tooltip for this buff and extract buffname
			CombustionTracker_Tooltip:SetOwner(UIParent, "ANCHOR_NONE");
			CombustionTracker_Tooltip:SetPlayerBuff(buffButton.index);
			local buffName = tostring(CombustionTracker_TooltipTextLeft1:GetText());
			CombustionTracker_Tooltip:Hide();
			
			--check if it is combustion buff
			if ( buffName and COMBUSTIONTRACKER_COMBUSTION==buffName ) then
				--set button as parent for scaling and anchor text to it
				CombustionTracker_MainFrame_CritNumber:SetParent(buffButton);
				CombustionTracker_MainFrame_CritNumber:SetPoint("TOP", buffButton, "BOTTOM", 0, 0);
				CombustionTracker_MainFrame_CritNumber:Show();
				
				--we found combustion buff and can stop going through bufflist
				return;
			end
		end
	end
	--no combustion buff found -> hide text
	CombustionTracker_MainFrame_CritNumber:Hide();
	--CombustionTracker_CombustionActive = false;
end
--]]


--updates text content
function CombustionTracker_UpdateText()
	CombustionTracker_MainFrame_CritNumber:SetText(CombustionTracker_CritsLeft);
end

--checks if a given message contains a fire spellname
function IsFirespellMessage(msg)
	local i=1;
	--go through the list of firespells and return true if one is found in the message
	while( COMBUSTIONTRACKER_FIRESPELLS[i] ) do
		if( string.find(msg, COMBUSTIONTRACKER_FIRESPELLS[i]) ) then
			return true;
		end
		i = i+1;
	end
	
	--else return false
	return false;
end



function CombustionTracker_OnLoad()
	--disable this mod if we are not a mage (not really disable but just do nothing)
	if (not (COMBUSTIONTRACKER_MAGE == UnitClass("player"))) then
		DEFAULT_CHAT_FRAME:AddMessage(COMBUSTIONTRACKER_DISABLED);
		return;
	end
	
	local welcome = "CombustionTracker v"..CombustionTracker_Version.." "..COMBUSTIONTRACKER_LOADED;
	
	--if the ElkBuffBar is used we change the positioning function and some text values
	if( getglobal("ElkBuffBarFrame") ) then
		CombustionTracker_UpdateTextPosition = CombustionTracker_UpdateTextPosition_ElkBuffBar;
		welcome = welcome.." Switched to ElkBuffBar mode.";
		
		CombustionTracker_MainFrame_CritNumber:SetFontObject(GameFontNormal);
		CombustionTracker_MainFrame_CritNumber:SetTextColor(1, 1, 1);
		CombustionTracker_MainFrame_CritNumber:SetJustifyH("RIGHT");
	
	elseif( getglobal("SatrinaBuffFrame") ) then
		CombustionTracker_UpdateTextPosition = CombustionTracker_UpdateTextPosition_SatrinaBuff;
		welcome = welcome.." Switched to SatrinaBuffFrame mode.";
		
		CombustionTracker_MainFrame_CritNumber:SetFontObject(GameFontNormalSmall);
		CombustionTracker_MainFrame_CritNumber:SetVertexColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	end
	
	--welcome message
	DEFAULT_CHAT_FRAME:AddMessage(welcome);

	--wait for player entering world
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
end